#include <bits/stdc++.h>

using namespace std;

class ST {
private:
    vector <int> t;
    int n;

    void relax(int pos) {
        t[pos] = max(t[2 * pos], t[2 * pos + 1]);
    }

    int _get(int pos, int l, int r, int a, int b) {
        if (l > b || a > r) {
            return 0;
        }
        if (a <= l && r <= b) {
            return t[pos];
        }
        int m = (l + r) / 2;
        return max(_get(2 * pos, l, m, a, b), _get(2 * pos + 1, m + 1, r, a, b));
    }

public:
    ST() {}
    ST(const vector <int> &v) {
        n = 1 << (32 - __builtin_clz(v.size()));
        t.resize(2 * n);

        for (int i = 0; i < (int) v.size(); i++) {
            t[n + i] = v[i];
        }

        for (int i = n - 1; i >= 1; i--) {
            relax(i);
        }
    }

    int get(int l, int r) {
        return _get(1, 1, n, l, r);
    }
};

const int N = 2e5 + 7;
int tin[N];
int tout[N];
int dp[N];
int depth[N];
int min_leaf_depth[N];
vector <int> g[N];
vector <int> on_depth[N];
ST st[N];
int T = 0;

void dfs(int v, int d = 0) {
    dp[v] = 0;
    tin[v] = T++;
    depth[v] = d;
    min_leaf_depth[v] = -1;
    on_depth[d].push_back(v);

    for (int u : g[v]) {
        dfs(u, d + 1);
        if (min_leaf_depth[v] == -1 || min_leaf_depth[u] < min_leaf_depth[v]) {
            min_leaf_depth[v] = min_leaf_depth[u];
        }
    }

    if (min_leaf_depth[v] == -1) {
        min_leaf_depth[v] = d;
    }
    tout[v] = T;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }

    dfs(1);
    for (int d = n - 1; d >= 0; d--) {
        if (on_depth[d].empty()) {
            continue;
        }
        vector <int> dps;
        for (int v : on_depth[d]) {
            if (depth[v] < min_leaf_depth[v]) {
                vector <int> &vs = on_depth[min_leaf_depth[v]];

                int l = lower_bound(vs.begin(), vs.end(), tin[v], [](int v, int x) { return tin[v] < x; }) - vs.begin();
                int r = upper_bound(vs.begin(), vs.end(), tout[v], [](int x, int v) { return x < tin[v]; }) - vs.begin();
                dp[v] = 1 + st[min_leaf_depth[v]].get(l + 1, r);
            }
            dps.push_back(dp[v]);
        }
        st[d] = ST(dps);
    }
    
    cout << dp[1] << '\n';
    return 0;
}