//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

//  w - vertices, d - edges
ll solve(vector<int> const& w, vector<int> const& d, int l, int r, int x) {
  ll const INF = ll(-1e18);
  ll ans = 0;
  for (int cyc = 0; cyc < 2; ++cyc) {
    ll dpOpen = INF, dpClose = INF;
    if (cyc == 0) {
      dpClose = 0;
      dpOpen = -w[l];
    } else {
      dpClose = dpOpen = -w[l];
    }
    for (int i = l + 1; i < r; ++i) {
      ll nopen = INF, nclose = INF;

      smax(nopen, dpClose - w[i]);
      smax(nopen, dpOpen - w[i] + d[i - 1]);
      smax(nclose, dpClose);
      smax(nclose, dpOpen - w[i] + d[i - 1]);

      dpOpen = nopen;
      dpClose = nclose;
    }
    if (cyc == 0) {
      smax(ans, dpClose);
    } else {
      smax(ans, dpOpen + x);
    }
  }
  return ans;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, q;
  cin >> n >> q;
  vector<int> w(n), d(n - 1);
  for (int& x : w) {
    cin >> x;
  }
  for (int& x : d) {
    cin >> x;
  }
  while (q--) {
    int t; cin >> t;
    if (t == 1) {
      int i, x;
      cin >> i >> x;
      w[i - 1] = x;
    } else if (t == 2) {
      int i, x;
      cin >> i >> x;
      d[i - 1] = x;
    } else {
      int l, r, x;
      cin >> l >> r >> x;
      --l;
      assert(r - l >= 2);
      cout << solve(w, d, l, r, x) << '\n';
    }
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
