#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

long long comb[5005][5005];

void precalc()
{
	comb[0][0] = 1;
	for (long long i = 1; i < 5005; i++)
	{
		comb[i][0] = 1;
		for (long long j = 1; j < 5005; j++)
		{
			comb[i][j] = (comb[i - 1][j] + comb[i - 1][j - 1]) % MOD;
		}
	}
}

long long dp[5005][5005];

void solve()
{
	long long n;
	cin >> n;
	if (n == 1)
	{
		cout << 1 << "\n";
		return;
	}

	dp[0][0] = 1;
	dp[1][1] = 1;
	for (long long i = 2; i <= n; i++)
	{
		for (long long j = (i + 1) / 2; j <= i; j++)
		{
			dp[i][j] = (dp[i - 1][j - 1] + dp[i - 2][j - 1]) % MOD;
		}
	}

	long long ans = 1;
	for (long long i = 2; i <= n; i++)
	{
		long long mul = 0;
		for (long long j = (i + 1) / 2; j < i; j++)
		{
			mul += (dp[i][j] * comb[i - 1][j]) % MOD;
			mul %= MOD;
		}
		ans = (ans * mul) % MOD;
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	precalc();

	solve();

	return 0;
}

/*

























*/
