#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

typedef long long ll;

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

struct ans {
	int a00, a01, a10, a11, f, l, ln;
};

vector<ans> tree;
string s;

ans relax(ans L, ans R) {
	ans ns = { 0, 0, 0, 0, 0, 0, 0 };
	ns.f = L.f;
	ns.l = R.l;
	ns.ln = L.ln + R.ln;
	if (L.ln == 1 && R.ln == 1) {
		ns.a00 = 1;
		ns.a01 = (R.f == 0);
		ns.a10 = (L.l == 0);
		ns.a11 = (L.f == 0 || R.f == 0);
		return ns;
	}
	if (L.ln == 1) {
		ns.a00 = R.a10;
		ns.a01 = R.a11;
		if (L.f == 0) {
			ns.a10 = (R.a00 | R.a10);
			ns.a11 = (R.a01 | R.a11);
		}
		else {
			if (R.f == 0) {
				ns.a10 = R.a00;
				ns.a11 = R.a01;
			}
		}
		return ns;
	}
	if (R.ln == 1) {
		ns.a00 = L.a01;
		ns.a10 = L.a11;
		if (R.f == 0) {
			ns.a01 = (L.a00 | L.a01);
			ns.a11 = (L.a10 | L.a11);
		}
		else {
			if (L.l == 0) {
				ns.a01 = L.a00;
				ns.a11 = L.a10;
			}
		}
		return ns;
	}
	bool ch = (L.l != R.f);
	if (L.a11 && R.a11) {
		ns.a11 = 1;
	}
	if (L.a10 && R.a01 && ch) {
		ns.a11 = 1;
	}
	if (L.a01 && R.a10) {
		ns.a00 = 1;
	}
	if (L.a00 && R.a00 && ch) {
		ns.a00 = 1;
	}
	if (L.a01 && R.a11) {
		ns.a01 = 1;
	}
	if (L.a00 && R.a01 && ch) {
		ns.a01 = 1;
	}
	if (L.a11 && R.a10) {
		ns.a10 = 1;
	}
	if (L.a10 && R.a00 && ch) {
		ns.a10 = 1;
	}
	return ns;
}

void build(int i, int l, int r) {
	if (l + 1 == r) {
		tree[i].f = tree[i].l = s[l] - 'a';
		tree[i].a11 = (s[l] == 'a');
		tree[i].a00 = 1;
		tree[i].ln = 1;
		return;
	}
	int mid = (l + r) / 2;
	build(2 * i + 1, l, mid);
	build(2 * i + 2, mid, r);
	tree[i] = relax(tree[2 * i + 1], tree[2 * i + 2]);
}

void upd(int i, int l, int r, int q, int wh) {
	if (l + 1 == r) {
		tree[i].f = tree[i].l = wh;
		tree[i].a11 = (wh == 0);
		return;
	}
	int mid = (l + r) / 2;
	if (q < mid) {
		upd(2 * i + 1, l, mid, q, wh);
	}
	else {
		upd(2 * i + 2, mid, r, q, wh);
	}
	tree[i] = relax(tree[2 * i + 1], tree[2 * i + 2]);
}

ans gt(int i, int l, int r, int lq, int rq) {
	if (lq <= l && r <= rq) {
		return tree[i];
	}
	int mid = (l + r) / 2;
	if (mid <= lq) {
		return gt(2 * i + 2, mid, r, lq, rq);
	}
	if (rq <= mid) {
		return gt(2 * i + 1, l, mid, lq, rq);
	}
	return relax(gt(2 * i + 1, l, mid, lq, rq), gt(2 * i + 2, mid, r, lq, rq));
}

void solve()
{
	int n; cin >> n;
	cin >> s;
	if (n == 1) {
		int q; cin >> q;
		for (int i = 0; i < q; ++i) {
			int t; cin >> t;
			if (t == 1) {
				int pos; cin >> pos;
				--pos;
				if (s[pos] == 'a') {
					s[pos] = 'b';
				}
				else {
					s[pos] = 'a';
				}
			}
			else {
				int l, r; cin >> l >> r;
				if (s == "a") {
					cout << "YES\n";
				}
				else {
					cout << "NO\n";
				}
			}
		}
		return;
	}
	tree.resize(4 * n, { 0, 0, 0, 0, 0, 0, 0 });
	build(0, 0, n);
	int q; cin >> q;
	for (int i = 0; i < q; ++i) {
		int t; cin >> t;
		if (t == 1) {
			int pos; cin >> pos;
			--pos;
			if (s[pos] == 'a') {
				s[pos] = 'b';
			}
			else {
				s[pos] = 'a';
			}
			upd(0, 0, n, pos, s[pos] - 'a');
		}
		else {
			int l, r; cin >> l >> r; --l;
			if (gt(0, 0, n, l, r).a11) {
				cout << "YES\n";
			}
			else {
				cout << "NO\n";
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	solve();

	return 0;
}

/*

























*/
