#include <iostream>
#include <vector>

using namespace std;

template<typename T, typename C>
pair<T, T> bin_search(T from, T to, C c)
{
	while (to - from > 1)
	{
		T mid = from + (to - from) / 2;

		if (c(mid))
		{
			to = mid;
		}
		else
		{
			from = mid;
		}
	}
}

int main()
{
	int n;

	cin >> n;

	vector<vector<int>> m(n + 1);

	for (int i = 0; i <= n; i++)
	{
		m[i].resize(n);

		m[i][0] = !i;

		for (int j = 1; j < n; j++)
		{
			m[i][j] = m[i][j - 1];

			if (i > 0)
			{
				m[i][j] += m[i - 1][j - 1];
				m[i][j] %= 1000000007;
			}
			if (i > 1)
			{
				m[i][j] += m[i - 2][j - 1];
				m[i][j] %= 1000000007;
			}
			//cout << m[i][j] << ' ';
		}
	}

	long long s = 1;

	for (int i = 1; i < n; i++)
	{
		s *= m[i + 1][i];
		s %= 1000000007;
	}

	cout << s;
}