#include <iostream>
#include <cmath>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

template<typename T, typename C>
pair<T, T> bin_search(T from, T to, C c)
{
	while (to - from > 1)
	{
		T mid = from + (to - from) / 2;

		if (c(mid))
		{
			to = mid;
		}
		else
		{
			from = mid;
		}
	}

	return { from, to };
}

long long cpow(int b, int n)
{
	long long m = b - 1;

	for (int i = 0; i < n; i++)
	{
		m *= b;

		if (m > 5000000000000000)	return 0;
	}

	return m;
}

int main()
{
	int n;

	cin >> n;

	long long d = bin_search(0LL, 1000000000000000000, [&](long long t) -> bool
		{
			cout << "? " << t << endl;

			int nn;

			cin >> nn; 

			return nn > n;
		}).second;

	//n++;

	int b = bin_search(1, 2023, [&](int t) -> bool
		{
			long long p = cpow(b, n);

			if (!p || p > 1000000000000000000)	return true;

			cout << "? " << d + p << endl;

			int nn;

			cin >> nn;

			return nn > n;
		}).second;

	cout << "! " << (long long)pow(b, n) - d << " " << b << endl;
}