#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;

#define int long long

int bin_pow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans = ans * a % MOD;
        }
        n /= 2;
        a = a * a % MOD;
    }
    return ans;
}

vector <int> fact, inv_fact;

int cnk(int n, int k) {
    return fact[n] * inv_fact[k] % MOD * inv_fact[n - k] % MOD;
}

void solve() {
    const int MAX = 1e5 + 50;
    fact.resize(MAX);
    inv_fact.resize(MAX);
    fact[0] = 1;
    for (int i = 1; i < MAX; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    inv_fact[MAX - 1] = bin_pow(fact[MAX - 1], MOD - 2);
    for (int i = MAX - 2; i >= 0; i--) {
        inv_fact[i] = inv_fact[i + 1] * (i + 1) % MOD;
    }

    int n;
    cin >> n;

    int ans = 0;
    for (int mex = 2; mex <= 1e9; mex++) {
        int s = 0;
        for (int i = 1; i < mex; i++) {
            s += i;
        }
        if (s > n) break;

        if (s == n) {
            ans += mex;
            continue;
        }

        vector <vector <int>> dp(mex, vector <int> (n - s + 1, 0));
        for (int i = 0; i <= n - s; i++) {
            dp[1][i] = 1;
        }
        for (int i = 1; i < mex; i++) {
            for (int j = 0; j <= n - s; j++) {
                for (int k = j; k >= 0; k -= i) {
                    dp[i][j] += dp[i - 1][k];
                    dp[i][j] %= MOD;
                }
            }
        }
        ans += mex * dp[mex - 1][n - s] % MOD;
        ans %= MOD;
    }

    cout << ans << "\n";
}

void solveE() {
    int n;
    cin >> n;

    int l = 0, r = 1e14;
    while (r - l > 1) {
        int m = (l + r) / 2;
        cout << "? " << m << endl;
        int x;
        cin >> x;
        if (x > n) {
            r = m;
        } else {
            l = m;
        }
    }

    int d1 = r;
    l = d1; r = 1e14;
    while (r - l > 1) {
        int m = (l + r) / 2;
        cout << "? " << m << endl;
        int x;
        cin >> x;
        if (x > n + 1) {
            r = m;
        } else {
            l = m;
        }
    }
    int d2 = r;

    for (int b = 2; b <= 2023; b++) {
        int res = b - 1;
        for (int i = 0; i < n; i++) {
            res *= b;
        }

        if (res == d2 - d1) {
            int bn = 1;
            for (int i = 0; i < n; i++) {
                bn *= b;
            }
            cout << "! " << bn - d1 << " " << b << endl;
            return;
        } else if (res >= 1e15) {
            cout << "! 1 2" << endl;
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solveE();
    }
}
