#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e6;

struct NodeData {
    int d;
    bool isLeave;
    int dp;
    int closestLeave;
    NodeData(): d(0), isLeave(0), dp(0), closestLeave(INF) {}

    bool operator > (NodeData other) {
        if (dp == other.dp)
            if (d == other.d)
                return isLeave < other.isLeave;
            else
                return d > other.d;
        return dp > other.dp;
    }
};

struct Node {
    vector<int> children;
    NodeData self;
    Node(): self() {}
};

vector<Node> g;

int dfs(int v, int p = -1, int d = 0) {
    g[v].self.d = d;
    g[v].self.isLeave = true;
    for(int u : g[v].children) {
        g[v].self.closestLeave = min(dfs(u, v, d+1), g[v].self.closestLeave);
        g[v].self.isLeave = false;
    }

    if (g[v].self.isLeave) {
        g[v].self.closestLeave = 0;
        g[v].self.dp = 1;
    }

    return g[v].self.closestLeave + 1;
}

NodeData solve(int v, int p = -1) {
    if (g[v].self.isLeave) {
        return g[v].self;
    }
    NodeData best;
    for(int u : g[v].children) {
        auto data = solve(u, v);
        if (data > best) {
            best = data;
        }
    }

    if (best.d - g[v].self.d  >= g[v].self.closestLeave + best.isLeave) {
        g[v].self.dp = best.dp + 1;
        return g[v].self;
    }
    else
        g[v].self.dp = best.dp;

    return best;
}


int main()
{
    int n;
    cin >> n;
    g.resize(n);
    for(int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].children.push_back(i);
    }

    dfs(0);
    cout << solve(0).dp << endl;


    return 0;
}
