#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
//using pi = pair<int, int>;
//using pl = pair<ll, ll>;
//using vi = vector<int>;
//using vl = vector<ll>;
//using vp = vector<pi>;
//using vpl = vector<pl>;
//#define f first
//#define s second

struct node
{
    int l, r;
    bool f1, f2, f3, f4;

    node(int v)
    {
        l = v;
        r = v;
         f2 = f3 = true;
         f4 = false;

        if(v == 0)
        {
            f1 = true;
        } else {
            f1 = false;
        }
    }
    node()
    {
        l = 0;
        r = 0;
        f1 = f2 = f3 = f4 = false;
    }
};

node merge(node a, node b)
{
    if(a.l == -1)
    {
        return b;
    }
    if(b.l == -1)
    {
        return a;
    }

    node c;
    c.l = a.l;
    c.r = b.r;

    c.f1 = (a.f1 && b.f1) || (a.f3 && b.f2 && a.r != b.l);
    c.f2 = (a.f2 && b.f1) || (a.f4 && b.f2 && a.r != b.l);
    c.f3 = (a.f1 && b.f3) || (a.f3 && b.f4 && a.r != b.l);
    c.f4 = (a.f2 && b.f3) || (a.f4 && b.f4 && a.r != b.l);
    return c;
}

struct D_o
{
    int n;
    vector<int> vec;
    vector<node> t;

    D_o(vector<int> &v)
    {
        vec = v;
        n = vec.size();
        t.resize(4 * n);

        build(0, 0, n);
    }

    void build(int v, int tl, int tr)
    {
        if(tl + 1 == tr)
        {
            t[v] = node(vec[tl]);
            return;
        }

        int tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm, tr);

        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

    node get(int v, int tl, int tr, int l, int r)
    {
        if(tr <= l || r <= tl)
        {
            return node(-1);
        }
        if(l <= tl && tr <= r)
        {
            return t[v];
        }

        int tm = (tl + tr) / 2;
        return merge(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
    }

    void upd(int v, int tl, int tr, int l, int r)
    {
        if(tr <= l || r <= tl)
        {
            return;
        }
        if(l <= tl && tr <= r)
        {
            int buf = t[v].l;
            if(buf == 0)
            {
                buf = 1;
            } else {
                buf = 0;
            }
            t[v] = node(buf);
            return;
        }

        int tm = (tl + tr) / 2;
        upd(2 * v + 1, tl, tm, l, r);
        upd(2 * v + 2, tm, tr, l, r);
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

};

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n;
    cin >> n;
    vector<int> v;
    for(int i = 0; i < n; ++i)
    {
        char c;
        cin >> c;
        v.push_back(c - 'a');
    }

    D_o gg(v);

    int q;
    cin >> q;
    for(int i = 0; i < q; ++i)
    {
        int buf;
        cin >> buf;
        if(buf == 1)
        {
            int pos;
            cin >> pos;
            --pos;
            gg.upd(0, 0, gg.n, pos, pos + 1);
        } else {
            int l, r;
            cin >> l >> r;
            --l;
            --r;
            node kek = gg.get(0, 0, gg.n, l, r + 1);
            if(kek.f1)
            {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }


}
