#include <bits/stdc++.h>
using namespace std;

#define vc vector
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

#define int long long
const int mod = 1e9 + 7;
const int N = 2e5 + 100;
const int inf = 1e9;

#define fi first
#define se second
struct SegTree {
    struct node {
        bool dp[2][2];
        string s;
        node(char c) {
            s = c;
            for (int i = 0; i < 2; i++) for (int j = 0; j < 2; j++) dp[i][j] = false;
            if (s == "a") {
                dp[0][0] = true;
            }
            dp[0][1] = true;
            dp[1][0] = true;
        }
        node() {
            s = "";
            for (int i = 0; i < 2; i++) for (int j = 0; j < 2; j++) dp[i][j] = false;
            dp[0][0] = true;
        }
    };
    node merge(node left, node right) {
        if (right.s.empty()) return left;
        if (left.s.empty()) return right;
        node ret;
        ret.dp[0][0] = false;
        ret.s = left.s + right.s;
        if (ret.s.size() > 2) {
            string w; w += ret.s[0]; w += ret.s.back();
            ret.s = w;
        }
        for (int pl = 0; pl < 2; pl++) {
            for (int sr = 0; sr < 2; sr++) {
                if (left.dp[pl][0] && right.dp[0][sr]) {
                    ret.dp[pl][sr] = true;
                }
                if (left.s.back() != right.s[0] && left.dp[pl][1] && right.dp[1][sr]) {
                    ret.dp[pl][sr] = true;
                }
            }
        }
        return ret;
    }
    vector<node> tree;
    string s;
    int n;
    void build(int v, int l, int r) {
        if (l == r - 1) {
            tree[v] = node(s[l]);
        } else {
            int m = (l + r) / 2;
            build(2 * v, l, m), build(2 * v + 1, m, r);
            tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
        }
    }
    SegTree(string ss) : s(ss), n(ss.size()), tree(4 * ss.size()) {
        build(1, 0, n);
    }
    void update(int v, int l, int r, int pos) {
        if (l == r - 1) {
            if (s[pos] == 'a') {
                s[pos] = 'b';
            } else {
                s[pos] = 'a';
            }
            tree[v] = node(s[pos]);
        } else {
            int m = (l + r) / 2;
            if (pos < m) {
                update(2 * v, l, m, pos);
            } else {
                update(2 * v + 1, m, r, pos);
            }
            tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
        }
    }
    node query(int v, int l, int r, int ql, int qr) {
        if (max(ql, l) >= min(r, qr)) return node();
        if (ql <= l && r <= qr) return tree[v];
        int m = (l + r) / 2;
        return merge(query(2 * v, l, m, ql, qr), query(2 * v + 1, m, r, ql, qr));
    }
    void update(int pos) {
        update(1, 0, n, pos);
    }
    bool query(int l, int r) {
        return query(1, 0, n, l, r + 1).dp[0][0];
    }
};
void solve_case() {
    /*
    3
    bab
    1
    2 1 3
    7
    abbabba
    4
    2 3 4
    2 3 5
    1 6
    2 3 7
     */
    int n;
    cin >> n;
    string s;
    cin >> s;
    SegTree st(s);
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int pos;
            cin >> pos;
            pos--;
            st.update(pos);
        } else {
            int l, r;
            cin >> l >> r;
            l--, r--;
            cout << (st.query(l, r) ? "YES\n" : "NO\n");
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; //cin >> tc;
    while (tc--) solve_case();
}
