#include <vector>
#include <iostream>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void dfs(int v, vector<vector<int>> &g, vector<int> &dp) {
    bool find = false;
    for (auto u : g[v]) {
        dfs(u, g, dp);
        dp[v] = max(dp[v], dp[u]);
        find |= (g[u].size() == 0);
    }
    if (find) {
        int mx = 0;
        for (auto u : g[v]) {
            if (g[u].size() != 0) {
                mx = max(mx, dp[u]);
            }
        }
        dp[v] = max(dp[v], mx + 1);
    }
}

void solve_b() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int v = 1; v < n; ++v) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(v);
    }
    vector<int> dp (n, 0);
    dfs(0, g, dp);
    /*for (auto i : dp) {
        cout << i << ' ';
    }
    cout << '\n';*/
    cout << dp[0];
}

void solve_f() {
    ll n;
    cin >> n;
    vector<vector<int>> a(n, vector<int> (n));
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
        }
    }
    ll sum = n * (n * n + 1) / 2;
    vector<ll> row(n, 0);
    int mn_i = -1, mx_i = -1;
    for (int i = 0; i < n; ++i) {
        ll x = 0;
        for (auto j : a[i]) {
            x += j;
        }
        row[i] = x;
        if (x < sum) {
            mn_i = i;
        } else if (x > sum) {
            mx_i = i;
        }
    }

    int mn_j = -1, mx_j = -1;
    vector<ll> col(n, 0);
    for (int j = 0; j < n; ++j) {
        ll x = 0;
        for (int i = 0; i < n; ++i) {
            x += a[i][j];
        }
        col[j] = x;
        if (x < sum) {
            mn_j = j;
        } else if (x > sum) {
            mx_j = j;
        }
    }
    if (mn_i != -1 && mn_j != -1) {
        cout << mn_i + 1 << ' ' << mn_j + 1 << '\n';
        cout << mx_i + 1 << ' ' << mx_j + 1 << '\n';
    } else if (mn_i == -1) {
        for (int i = 0; i < n; ++i) {
            int x = a[i][mn_j], y = a[i][mx_j];
            if (col[mn_j] - x + y == sum && col[mx_j] - y + x == sum) {
                cout << i + 1 << ' ' << mn_j + 1 << '\n';
                cout << i + 1 << ' ' << mx_j + 1 << '\n';
                return;
            }
        }
    } else {
        for (int j = 0; j < n; ++j) {
            int x = a[mn_i][j], y = a[mx_i][j];
            if (row[mn_i] - x + y == sum && row[mx_i] - y + x == sum) {
                cout << mn_i + 1 << ' ' << j + 1 << '\n';
                cout << mx_i + 1 << ' ' << j + 1 << '\n';
                return;
            }
        }
    }
}

const ll MOD = 1e9 + 7;

void solve_d(){
    ll n;
    cin >> n;
    vvll dp(n, vll(n, 0));
    for (int i = 0; i < n; ++i) {
        dp[i][0] = 1;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dp[i][j] = dp[i - 1][j] + dp[i - 1][j - 1] + dp[i - 1][j - 2];
            dp[i][j] %= MOD;
        }
    }
    ll ans = 1;
    for (int i = 3; i <= n; ++i) {
        ans = ans * dp[i - 1][i - 2];
        ans %= MOD;
    }
    cout << ans;
}

ll bin_pow(ll a, ll k) {
    if (k == 0) {
        return 1;
    }
    ll b = bin_pow(a, k / 2);
    if (k % 2 == 0) {
        return (b * b) % MOD;
    }
    return ((b * b % MOD) * a) % MOD;
}

void solve_g() {
    int n;
    cin >> n;
    vector<int> v(n);
    int a = 0, b = 0, c = 0;
    for (auto &i : v) {
        cin >> i;
        a += (i % 3 == 0);
        b += (i % 3 == 1);
        c += (i % 3 == 2);
    }
    vector<ll> f(n + 1, 1);
    for (int i = 2; i <= n; ++i) {
        f[i] = f[i - 1] * i % MOD;
    }

    auto c_n_k = [&f] (int n, int k) {
        return ((f[n] * bin_pow(f[k], MOD - 2)) % MOD * bin_pow(f[n - k], MOD - 2)) % MOD;
    };

    //cout << b << ' ' << c << endl;
    if (abs(b - c) >= 3 || b == c) {
        cout << 0;
    } else {
        cout << f[b] * f[c] % MOD * f[a] % MOD * c_n_k(n - 1, a) % MOD;
    }
    /*cout << '\n';
    for (auto i : f) {
        cout << i << ' ';
    }
    cout << '\n';*/
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve_g();
    }
    return 0;
}
