#include <vector>
#include <iostream>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;

ll bin_pow(ll a, ll k) {
    if (k == 0) {
        return 1;
    }
    ll b = bin_pow(a, k / 2);
    if (k % 2 == 0) {
        return (b * b);
    }
    return ((b * b) * a);
}

void dfs(int v, vector<vector<int>> &g, vector<int> &dp) {
    bool find = false;
    for (auto u : g[v]) {
        dfs(u, g, dp);
        dp[v] = max(dp[v], dp[u]);
        find |= (g[u].size() == 0);
    }
    if (find) {
        int mx = 0;
        for (auto u : g[v]) {
            if (g[u].size() != 0) {
                mx = max(mx, dp[u]);
            }
        }
        dp[v] = max(dp[v], mx + 1);
    }
}

void solve_b() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int v = 1; v < n; ++v) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(v);
    }
    vector<int> dp (n, 0);
    dfs(0, g, dp);
    /*for (auto i : dp) {
        cout << i << ' ';
    }
    cout << '\n';*/
    cout << dp[0];
}

void solve_i() {
    ll n;
    cin>>n;
    set<pair<ll,ll>> used;
    map<ll,pair<ll,ll>> v,h;
    ll smvc=0,smvn=0,smhc=0,smhn=0;
    for(int I=0;I<n;I++) {
        ll x,y;
        cin>>x>>y;
        if(used.find({x,y})!=used.end()) {
            cout<<max(max(smvc,smvn),max(smhc,smhn))<<'\n';
            continue;
        }
        used.insert({x,y});
        if(x%2==0 && y%2==0) {
            smvc-=max(v[x].first,v[x].second);
            v[x].first++;
            smvc+=max(v[x].first,v[x].second);
            smhc-=max(h[y].first,h[y].second);
            h[y].first++;
            smhc+=max(h[y].first,h[y].second);
        }
        if(x%2==0 && y%2==1) {
            smvc-=max(v[x].first,v[x].second);
            v[x].second++;
            smvc+=max(v[x].first,v[x].second);
            smhn-=max(h[y].first,h[y].second);
            h[y].first++;
            smhn+=max(h[y].first,h[y].second);
        }
        if(x%2==1 && y%2==0) {
            smvn=max(v[x].first,v[x].second);
            v[x].first++;
            smvn+=max(v[x].first,v[x].second);
            smhc-=max(h[y].first,h[y].second);
            h[y].second++;
            smhc+=max(h[y].first,h[y].second);
        }
        if(x%2==1 && y%2==1) {
            smvn-=max(v[x].first,v[x].second);
            v[x].second++;
            smvn+=max(v[x].first,v[x].second);
            smhn-=max(h[y].first,h[y].second);
            h[y].second++;
            smhn+=max(h[y].first,h[y].second);
        }
        cout<<max(max(smvc,smvn),max(smhc,smhn))<<'\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(0);
    //COMMENTED
    int t = 1;
    //cin >> t;
    while(t--) {
        solve_i();
    }
    return 0;
}
