#include <bits/stdc++.h>

using namespace std;

#define int long long

struct SegmentTree {
    vector<int> a, tree;
    int n;

    void build(int l, int r, int ind) {
        if (l + 1 == r) {
            tree[ind] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(l, mid, ind * 2  + 1);
        build(mid, r, ind * 2 + 2);
        tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 2]);
    }

    SegmentTree() {}

    SegmentTree(vector<int> &_a) {
        a = _a;
        n = (int) a.size();
        tree.resize(4 * n, 0);
        build(0, n, 0);
    }

    void upd(int l, int r, int pos, int val, int ind) {
        if (l + 1 == r) {
            tree[ind] = a[l] = val;
            return;
        }
        int mid = (l + r) / 2;
        if (pos < mid) upd(l, mid, pos, val, ind * 2 + 1);
        else upd(mid, r, pos, val, ind * 2 + 2);
        tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 2]);
    }

    int get(int l, int r, int ql, int qr, int ind) {
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr) return tree[ind];
        int mid = (l + r) / 2;
        return max(get(l, mid, ql, qr, ind * 2 + 1), get(mid, r, ql, qr, ind * 2 + 2));
    }
};

vector<vector<int>> g;
vector<vector<int>> h;
vector<int> pos, deep, tin, ans;
vector<int> min_way;
vector<SegmentTree> H;
int T = 0;

void dfs1(int u) {
    pos[u] = (int) h[deep[u]].size();
    h[deep[u]].push_back(u);
    tin[u] = T++;
    if (g[u].size() != 0) min_way[u] = 1e9;
    for (int v : g[u]) {
        deep[v] = deep[u] + 1;
        dfs1(v);
        min_way[u] = min(min_way[v] + 1, min_way[u]);
    }
}

int max_ans(int dp, int t) {
    int l = -1, r = (int) h[dp].size();
    while(r - l > 1) {
        int mid = (l + r) / 2;
        if (tin[h[dp][mid]] > t) r = mid;
        else l = mid;
    }
    return H[dp].get(0, (int) h[dp].size(), r, (int) h[dp].size(), 0);
}

void dfs2(int u) {
    for (int v : g[u]) {
        dfs2(v);
    }
    if (min_way[u] == 0) {
        ans[u] = 0;
        return;
    }
    ans[u] = 1 + max_ans(deep[u] + min_way[u], tin[u]);
    H[deep[u]].upd(0, (int) h[deep[u]].size(), pos[u], ans[u], 0);
}

void Fast() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

signed main() {
    Fast();
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    h.resize(n);
    pos.resize(n, 0);
    deep.resize(n, 0);
    tin.resize(n, 0);
    min_way.resize(n, 0);
    ans.resize(n, 0);
    dfs1(0);
    H.resize(n);
    for (int i = 0; i < n; i++) {
        if (h[i].empty()) break;
        vector<int> cur(h[i].size(), 0);
        H[i] = SegmentTree(cur);
    }
    dfs2(0);
    cout << ans[0];
}
