#include <bits/stdc++.h>
//#define int long long
#define pb push_back
using namespace std;

struct SegTree {
    struct Node {
        array<array<bool, 3>, 3> dp{};

        Node() {
            dp[0][0] = 1; // pustoy huy
        }

        Node(int t) {
            dp[0][0] = 0;
            dp[t][0] = 1;
            dp[0][t] = 1;
            if (t == 1) {
                dp[0][0] = 1;
            }
        }
    };

    vector<Node> tree;
    int n;

    Node pull(const Node &a, const Node &b) {
        Node ans;
        ans.dp[0][0] = 0;
        for (int li = 0; li < 3; ++li) {
            for (int ri = 0; ri < 3; ++ri) {
                ans.dp[li][ri] |= (a.dp[li][0] && b.dp[0][ri]);
                ans.dp[li][ri] |= (a.dp[li][0] && b.dp[1][ri]);
                ans.dp[li][ri] |= (a.dp[li][1] && b.dp[0][ri]);
                ans.dp[li][ri] |= (a.dp[li][1] && b.dp[2][ri]);
                ans.dp[li][ri] |= (a.dp[li][2] && b.dp[1][ri]);
                ans.dp[li][ri] |= (a.dp[li][1] && b.dp[1][ri]);
            }
        }
        return ans;
    }

    void build(int v, int l, int r, const string &s) {
        if (l + 1 == r) {
            int t = s[l] - 'a' + 1;
            tree[v] = Node(t);
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, s);
        build(2 * v + 2, m, r, s);
        tree[v] = pull(tree[2 * v + 1], tree[2 * v + 2]);
    }

    SegTree(string s) {
        n = s.size();
        tree.resize(4 * n);
        build(0, 0, n, s);
    }

    void update(int v, int l, int r, int i, int t) {
        if (l + 1 == r) {
            tree[v] = Node(t);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            update(2 * v + 1, l, m, i, t);
        } else {
            update(2 * v + 2, m, r, i, t);
        }
        tree[v] = pull(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void update(int i, int t) {
        update(0, 0, n, i, t);
    }

    Node get(int v, int l, int r, int li, int ri) {
        if (li >= r || l >= ri) {
            return Node();
        }
        if (li <= l && r <= ri) {
            return tree[v];
        }
        int m = (l + r) / 2;
        return pull(get(2 * v + 1, l, m, li, ri), get(2 * v + 2, m, r, li, ri));
    }

    bool get(int li, int ri) {
        return get(0, 0, n, li, ri).dp[0][0];
    }
};

signed main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int q;
    cin >> q;
    SegTree st(s);
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int i;
            cin >> i;
            --i;
            s[i] ^= ('a' ^ 'b');
            st.update(i, s[i] - 'a' + 1);
        } else {
            int l, r;
            cin >> l >> r;
            --l;
            bool f = st.get(l, r);
            if (f) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
}
