#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

const ll maxn = 1e5, mod = 1e9 + 7;

ll fct[maxn + 1];

ll bp(ll a, ll b) {
	ll res = 1;
	while (b) {
		if (b % 2 == 1) res = a * res % mod;
		b /= 2;
		a = a * a % mod;
	}
	return res;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	fct[0] = 1;

	for (ll i = 1; i <= maxn; ++i) {
		fct[i] = fct[i - 1] * i % mod;
	}

	int n;
	ll cnt0 = 0, cnt1 = 0, cnt2 = 0;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (a % 3 == 0) {
			++cnt0;
		}
		else if (a % 3 == 1) {
			++cnt1;
		}
		else {
			++cnt2;
		}
	}

	ll res = 1;

	if (abs(cnt1 - cnt2) != 1 && abs(cnt1 - cnt2) != 2) {
		cout << 0;
		return 0;
	}

	res = fct[cnt1] * fct[cnt2] % mod;

	res = res * (fct[n - 1] * bp(fct[n - cnt0 - 1], mod - 2)%mod) % mod;
	cout << res;

	return 0;
}