#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

ll pow2(ll a, ll b) {
    if (b == 0) return 1ll;
    if (b == 1) return (a);
    ll x = pow2(a, b / 2);
    x = x * x;
    if (b % 2 == 0) {
        return x;
    } else {
        return (a * x);
    }
}
vector<vector<int>> g;
vector<int> h;
vector<int> dp;
vector<int> cnt;

void dfs(int v = 0, int hei = 0) {
    h[v] = hei;
    dp[v] = 1e9;
    cnt[v] = 1;
    for (int u: g[v]) {
        dfs(u, hei + 1);
        dp[v] = min(dp[v], dp[u] + 1);
        cnt[v] += cnt[u];
    }
    if (dp[v] == 1e9)
        dp[v] = 0;
}

int rec(int v, int f) {
    f--;
    if (f == 0) {
        int new_h = dp[v];
        if (new_h == 0)
            return 0;
        int res = 0;
        if (cnt[v] == new_h + 1)
            return 1;
        for (int u: g[v]) {
            res = max(rec(u, new_h), res);
        }
        return res + 1;
    }
    int res = 0;
    for (int u: g[v]) {
        res = max(rec(u, f), res);
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n; cin >> n;
    h.resize(n);
    g.resize(n);
    dp.resize(n);
    cnt.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u; cin >> u;
        g[u - 1].push_back(i + 1);
    }
    dfs();
    cout << rec(0, 1);
    return 0;

}
