#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll>> a(n, vector<ll> (n));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++){
            cin >> a[i][j];
        }
    }
    vector<pair<ll, ll>> sum(n * 2, {0, 0});
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++){
            sum[i].first += a[i][j];
        }
        sum[i].second = i;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++){
            sum[i + n].first += a[j][i];
        }
        sum[i + n].second = i + n;
    }
    sort(sum.begin(), sum.end());
    bool same = true;
    for (ll i = 0; i < 2 * n - 1 && same; i++) {
        if (sum[i].first != sum[i + 1].first) {
            same = false;
        }
    }
    if (same) {
        vector<vector<ll>> b;
        for (ll i = 0; i < n; i++){
            for (ll j = 0; j < n; j++){
                b.push_back({a[i][j], i, j});
            }
        }
        sort(b.begin(), b.end());
        for (ll i = 0; i < n * n - 1; i++) {
            if (b[i][0] == b[i + 1][0]) {
                cout << b[i][1] + 1 << " " << b[i][2] + 1 << '\n';
                cout << b[i + 1][1] + 1 << " " << b[i + 1][2] + 1 << '\n';
                return 0;
            }
        }
        return 0;
    }
    vector<ll> ind;
    ind.push_back(sum[0].second);
    ind.push_back(sum[1].second);
    ind.push_back(sum[2 * n - 1].second);
    ind.push_back(sum[2 * n - 2].second);
    sort(ind.begin(), ind.end());
    ind[3] -= n;
    ind[2] -= n;
    if (a[ind[0]][ind[2]] != a[ind[1]][ind[3]]) {
        cout << ind[0] + 1 << " " << ind[2] + 1 << '\n';
        cout << ind[1] + 1 << " " << ind[3] + 1 << '\n';
    } else {
        cout << ind[0] + 1 << " " << ind[3] + 1 << '\n';
        cout << ind[1] + 1 << " " << ind[2] + 1 << '\n';
    }
    return 0;
}
