#include <bits/stdc++.h>

using namespace std;
//#define int long long
typedef long long ll;

#define int long long
const long long nmax = 2e5 + 100, MOD = 1e9 + 7, N = 1e3 + 10;
const long long inf = 2e5 + 100;

#define sz(a) (a.size())

int binpow(int a, int n, int m) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = (res * a) % m;
        }
        a = (a * a) % m;
        n >>= 1;
    }
    return res;
}

vector<int> inv_fact(nmax), fact(nmax);

void calc_inv() {
    fact[0] = 1;
    inv_fact[0] = binpow(1, MOD - 2, MOD);
    for (int i = 1; i < nmax; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
        inv_fact[i] = binpow(fact[i], MOD - 2, MOD);
    }
}

int cnk(int n, int k) {
    if (k > n) {
        assert(0);
        return -1;
    }
    return ((fact[n] * inv_fact[n - k]) % MOD * inv_fact[k]) % MOD;
}

vector<vector<int>> a;

int get(int x1, int y1, int x2, int y2, vector<vector<int>> &pref) {
    int cur = pref[x2][y2];
    if (x1 > 0) {
        cur -= pref[x1 - 1][y2];
    }
    if (y1 > 0) {
        cur -= pref[x2][y1 - 1];
    }
    if (x1 > 0 && y1 > 0) {
        cur += pref[x1 - 1][y1 - 1];
    }
    return cur;
}

struct ms{
    int x1, y1, x2, y2;
    ms(){}
    ms(int a, int b, int c, int d) {
        x1 = a, y1 = b, x2 = c, y2 = d;
    }
};

vector<vector<int>> calc_pref(int n) {
    vector<vector<int>> pref(n, vector<int>(n));
    pref[0][0] = a[0][0];
    for (int i = 1; i < n; i++) {
        pref[i][0] = pref[i - 1][0] + a[i][0];
    }
    for (int j = 1; j < n; j++) {
        pref[0][j] = pref[j][j - 1] + a[0][j];
    }
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < n; j++) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];
        }
    }
    return pref;
}

bool check(int n, vector<vector<int>> &pref) {
    int c = 2 * n - 4;
    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cnt[get(0, i, n - 1, i, pref)]++;
        cnt[get(i, 0, i, n - 1, pref)]++;
    }
    int sum;
    for (auto &[x, y] : cnt) {
        if (y == c) {
            sum = x;
            break;
        }
    }
    for (int i = 0; i < n; i++) {
        int st = get(0, i, n - 1, i, pref), str = get(i, 0, i, n - 1, pref);
        if (st != sum) {
            return false;
        }
        if (str != sum) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    a.resize(n, vector<int>(n));
    for (auto &e : a) {
        for (int &k : e) {
            cin >> k;
        }
    }
    vector<vector<int>> pref = calc_pref(n);
    int c = 2 * n - 4;
    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cnt[get(0, i, n - 1, i, pref)]++;
        cnt[get(i, 0, i, n - 1, pref)]++;
    }
    int sum;
    for (auto &[x, y] : cnt) {
        if (y == c) {
            sum = x;
            break;
        }
    }
    vector<ms> v;
    for (int i = 0; i < n; i++) {
        int st = get(0, i, n - 1, i, pref), str = get(i, 0, i, n - 1, pref);
        if (st != sum) {
            v.push_back({0, i, n - 1, i});
        }
        if (str != sum) {
            v.push_back({i, 0, i, n - 1});
        }
    }
    int sz = (int)v.size();
    set<pair<int, int>> st;
    for (int i = 0; i < sz; i++) {
        for (int j = i + 1; j < sz; j++) {
            if ((v[i].x1 == v[j].x1 && v[i].x2 == v[j].x2) || (v[i].y1 == v[j].y1 && v[i].y2 == v[j].y2)) {
                continue;
            }
            ms b = v[i], d = v[j];
            if (v[j].x1 == 0 && v[j].x2 == n - 1) {
                swap(b, d);
            }
            st.insert({b.y1, d.x1});
        }
    }
    sz = (int)st.size();
    vector<pair<int, int>> v1;
    while (!st.empty()) {
        v1.push_back(*st.begin());
        st.erase(st.begin());
    }
    cout << sz << '\n';
    for (int i = 0; i < sz; i++) {
        for (int j = i + 1; j < sz; j++) {
            swap(a[v1[i].first][v1[i].second], a[v1[j].first][v1[j].second]);
            vector<vector<int>> pref1 = calc_pref(n);
            if (check(n, pref1)) {
                cout << v1[i].first + 1 << ' ' << v1[i].second + 1 << '\n';
                cout << v1[j].first + 1 << ' ' << v1[j].second + 1;
                exit(0);
            }
            swap(a[v1[i].first][v1[i].second], a[v1[j].first][v1[j].second]);
        }
    }
}

void solve1() {
    int n;
    cin >> n;
    int ans = 1;
    vector<vector<int>> dp(n + 1, vector<int> (n + 2));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n + 1; j++) {
            if (j >= 2)
                dp[i][j] = ((dp[i - 1][j] + dp[i - 1][j - 1]) % MOD + dp[i - 1][j - 2]) % MOD;
            else if (j >= 1)
                dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]) % MOD;
            else
                dp[i][j] = dp[i - 1][j];
        }
    }
    for (int i = 1; i < n; i++) {
        ans = (ans * dp[i][i + 1]) % MOD;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve1();

//    solve();

//    calc_inv();
//
//    int n;
//    cin >> n;
//    ll k0 = 0, k1 = 0, k2 = 0;
//    ll a;
//    for (int i = 0; i < n; i++) {
//        cin >> a;
//        if (a%3 == 0) k0++;
//        if (a%3 == 1) k1++;
//        if (a%3 == 2) k2++;
//    }
//    if (k1 == k2) {
//        cout << 0;
//        return 0;
//    }
//    //cout << k0 << " " << k1 << " " << k2 << '\n';
//    ll ans = 0;
//    if (k1%2 == 0 && k1 + 1 == k2 || k1%2 == 0 && k1 + 2 == k2 || k1%2 == 0 && k1 - 1 == k2) {
//        ans += (((cnk(k1 + k2 + k0 - 1, k0)*fact[k1])%MOD)*fact[k2])%MOD;
//    }
//    if (k2%2 == 0 && k2 + 1 == k1 || k2%2 == 0 && k2 + 2 == k1 || k2%2 == 0 && k2 - 1 == k1) {
//        ans += (((cnk(k1 + k2 + k0 - 1, k0)*fact[k1])%MOD)*fact[k2])%MOD;
//    }
//    cout << ans;
    return 0;
}
