#include<bits/stdc++.h>
using namespace std;

int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a +  b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

int binpow(int a, int n) {
    int res = 1;
    for (; n; n >>= 1) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
    }
    return res;
}

struct segtree {
    int n;
    vector<int> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(vector<int>(2 * n, -1e9)) {}

    void update(int k, int x) {
        for (tr[k += n] = x; k; k >>= 1, tr[k] = max(tr[k << 1], tr[k << 1 | 1]));
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res,tr[l++]);
            if (~r & 1) res = max(res,tr[r--]);
        }
        return res;
    }
};

const int N= 2e5;
int tin[N], tout[N], d[N];
segtree tr[N];
vector<int> vv[N];
vector<int> g[N];
int pos[N];

int tim = 0;
void dfs(int u) {
    tin[u] = tim++;
    pos[u] = vv[d[u]].size();
    vv[d[u]].push_back(tin[u]);
    for (auto to : g[u]) {
        d[to] = d[u] + 1;
        dfs(to);
    }
    tout[u] = tim - 1;
}

int dp[N];
int nearest[N];
void go(int u) {
    nearest[u] = 1e9;
    if (g[u].size() == 0) {
        nearest[u] = 0;
        dp[u] = 0;
        tr[d[u]].update(pos[u], dp[u]);
        return;
    }
    for (auto to : g[u]) {
        go(to);
        nearest[u] = min(nearest[u], nearest[to] + 1);
    }
    int dep = d[u] + nearest[u];
    int ql = lower_bound(vv[dep].begin(), vv[dep].end(), tin[u]) - vv[dep].begin();
    int qr = upper_bound(vv[dep].begin(), vv[dep].end(), tout[u]) - vv[dep].begin() - 1;
    cout << u << ' ' << ql << ' ' << qr << ' '<< dep << endl;
    dp[u] = tr[dep].get(ql, qr) + 1;
    tr[d[u]].update(pos[u], dp[u]);
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    dfs(0);
    for (int i = 0; i < n;++i) tr[i] = segtree(vv[i].size());
    go(0);
    cout << dp[0];
}