#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 5;

vector<int> g[MAXN];
int h[MAXN], leaf[MAXN], ans[MAXN];

void dfs(int v, set<pair<int, int>> &root) {
    ans[v] = 1;
    leaf[v] = MAXN;

    if (g[v].empty()) {
        leaf[v] = h[v];
    }

    for (auto to : g[v]) {
        h[to] = h[v] + 1;

        ans[v] = max(ans[v], ans[to]);
        set<pair<int, int>> tmp;
        dfs(to, tmp);

        leaf[v] = min(leaf[v], leaf[to]);

        if ((int)root.size() < (int)tmp.size()) {
            swap(root, tmp);
        }
        for (auto kid : tmp) {
            root.insert(kid);
        }
    }

    auto it = root.lower_bound({leaf[v] + 1, -MAXN});
    if (it != root.end()) {
        ans[v] = -it->second + 1;
    }

    root.insert({h[v], -ans[v]});
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;

        g[p].push_back(i);
    }

    set<pair<int, int>> govno;
    dfs(0, govno);

    cout << ans[0];
}