#include <iostream>
#include <map>
#include <utility>
#include <algorithm>
#include <stdint.h>
#include <vector>

using namespace std;

std::pair<uint32_t, uint32_t> deepest(vector<vector<uint32_t>>& children, uint32_t v) {
	pair<uint32_t, uint32_t> r = { v, 0 };
	for (const auto& child : children[v]) {
		auto c = deepest(children, child);
		c.second++;
		if (c.second > r.second) r = c;
	}
	return r;
}

uint32_t shrt(vector<vector<uint32_t>>& children, vector<uint32_t>& shortest, uint32_t v) {
	if (children[v].empty()) return 0;
	pair<uint32_t, uint32_t> r = { v, UINT32_MAX };
	for (const auto& child : children[v]) {
		auto c = shrt(children, shortest, child);
		c++;
		if (c < r.second) r = { child, c };
	}
	shortest[v] = r.first;
	return r.second;
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	uint32_t n;
	cin >> n;
	vector<int32_t> parent(n);
	vector<vector<uint32_t>> children(n);
	parent[0] = -1;
	for (uint32_t i = 1; i < n; i++) {
		std::cin >> parent[i];
		parent[i]--;
		children[parent[i]].push_back(i);
	}
	auto target = deepest(children, 0).first;
	vector<uint32_t> shortest(n);
	shrt(children, shortest, 0);
	std::vector<uint32_t> path;
	while (target != 0) {
		path.push_back(target);
		target = parent[target];
	}
	std::reverse(path.begin(), path.end());
	path.pop_back();
	uint32_t count = 1;
	uint32_t red = 0;
	for (auto blue : path) {
		red = shortest[red];
		if (children[red].empty()) {
			red = blue;
			count++;
		}
	}
	std::cout << count;
}
