#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct node {
    int len;
    char L, R;
    array<array<bool, 2>, 2> dp;
    node() {
        dp[0][0] = dp[0][1] = dp[1][1] = dp[1][0] = false;
        len = 0;
        L = 'X', R = 'X';
    }
};

string s;

const int N = 1e5 + 10;
node t[4 * N];

node Merge(const node &a, const node &b) {
    if (a.len == 0) {
        return b;
    }
    if (b.len == 0) {
        return a;
    }
    node c = node();
    c.len = a.len + b.len;
    c.L = a.L;
    c.R = b.R;
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < 2; j++) {
            if (a.dp[i][1] && b.dp[1][j]) {
                c.dp[i][j] = 1;
            }
            int new_i = i, new_j = j;
            if (a.dp[i][0] && b.dp[0][j] && a.R != b.L) {
                if (a.len == 1) {
                    new_i = 1;
                }
                if (b.len == 1) {
                    new_j = 1;
                }
                c.dp[new_i][new_j] = 1;
            }
        }
    }
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < 2; j++) {
            if (c.dp[i][j]) {
                if (c.L == 'a') {
                    c.dp[1][j] = 1;
                }
                if (c.R == 'a') {
                    c.dp[i][1] = 1;
                }
            }
        }
    }
    return c;
}

void update(int v, int l, int r, int pos) {
    if (l == r) {
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 2; j++) {
                t[v].dp[i][j] = 0;
            }
        }
        t[v].len = 1;
        t[v].dp[0][0] = 1;
        t[v].L = t[v].R = s[pos];
        if (s[pos] == 'a') {
            t[v].dp[1][1] = 1;
        }
        return;
    }
    int m = (l + r) / 2;
    if (pos <= m) {
        update(2 * v, l, m, pos);
    } else {
        update(2 * v + 1, m + 1, r, pos);
    }
    t[v] = Merge(t[v * 2], t[v * 2 + 1]);
}

node get(int v, int tl, int tr, int l, int r) {
    if (l > r) return node();
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return Merge(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    cin >> s;
    for (int i = 0; i < n; i++) {
        update(1, 0, n - 1, i);
    }
    int q;
    cin >> q;
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int pos;
            cin >> pos;
            pos--;
            s[pos] = s[pos] ^ 'a' ^ 'b';
            update(1, 0, n - 1, pos);
        } else {
            int l, r;
            cin >> l >> r;
            l--, r--;
            if (l == r) {
                cout << (s[l] == 'a' ? "YES\n" : "NO\n");
            } else {
                node ans = get(1, 0, n - 1, l, r);
                cout << (ans.dp[1][1] ? "YES\n" : "NO\n");
            }
        }
    }
    return 0;
}