#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first

const int mod = 1e9 + 7;

struct Modint {
    int x;
    Modint() {
        x = 0;
    }
    Modint (int _x) {
        while (_x >= mod) { _x -= mod; }
        while (_x < 0) { _x += mod; }
        x = _x;
    }
    Modint (long long _x) {
        if (_x >= mod || _x <= -mod) { _x %= mod; }
        if (_x < 0) { _x += mod; }
        x = _x;
    }
    Modint operator+(const Modint& other) const {
        return Modint(x + other.x);
    }
    Modint operator*(const Modint& other) const {
        return Modint(x * 1ll * other.x);
    }
    void operator+=(const Modint& other) {
        *this = *this + other;
    }
    void operator*=(const Modint& other) {
        *this = *this * other;
    }
    Modint operator^(int k) {
        Modint res = 1, tmp = x;
        while (k > 0) {
            if (k & 1) {
                res *= tmp;
            }
            tmp *= tmp;
            k >>= 1;
        }
        return res;
    }
    ~Modint() {}
};

vector<Modint> fact, invFact;

void buildFact(int n) {
    fact.resize(n + 1);
    invFact.resize(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    invFact[n] = fact[n] ^ (mod - 2);
    for (int i = n; i > 0; --i) {
        invFact[i - 1] = invFact[i] * i;
    }
}

Modint C(int n, int k) {
    if (n < 0 || k < 0 || n < k) { return 0; }
    return fact[n] * invFact[k] * invFact[n - k];
}

void solve() {
    int n;
    cin >> n;
    vector<int> cnt(3);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        ++cnt[x % 3];
    }
    Modint ans = 0;
    if (cnt[1] >= 2 && (cnt[1] - 2 == cnt[2] || cnt[1] - 2 + 1 == cnt[2])) {
        ans += 1;
    } else if (cnt[1] == 1 && cnt[2] == 0) {
        ans += 1;
    }
    if (cnt[2] >= 2 && (cnt[2] - 2 == cnt[1] || cnt[2] - 2 + 1 == cnt[1])) {
        ans += 1;
    } else if (cnt[2] == 1 && cnt[1] == 0) {
        ans += 1;
    }
    ans *= fact[cnt[1]];
    ans *= fact[cnt[2]];
    ans *= C(cnt[1] + cnt[2] - 1 + cnt[0], cnt[0]) * fact[cnt[0]];
    cout << ans.x << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    buildFact(200010);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
