#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

const int MOD = 1e9 + 7;
const int MAXN = 2e5;

int qpow(int a, int n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0)
        return qpow(a * a % MOD, n / 2);
    return a * qpow(a * a % MOD, n / 2) % MOD;
}

int inv(int n) {
    return qpow(n, MOD - 2);
}

vector<int> f, invf;

void precalc() {
    f.assign(MAXN, 1);
    for (int i = 1; i < MAXN; ++i)
        f[i] = f[i - 1] * i % MOD;

    invf.assign(MAXN, 0);
    for (int i = 0; i < MAXN; ++i)
        invf[i] = inv(f[i]);
}

int C(int n, int k) {
    return (f[n] * invf[k] % MOD) * invf[n - k] % MOD;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    vector<int> cnt(3);
    for (auto i : a)
        ++cnt[i % 3];

    if (abs(cnt[1] - cnt[2]) > 2 || cnt[1] == cnt[2]) {
        cout << 0 << endl;
        return;
    }

    int ans = f[cnt[1]] * f[cnt[2]] % MOD;

    ans = (ans * C(cnt[0] + cnt[1] + cnt[2] - 1, cnt[1] + cnt[2] - 1)) % MOD * f[cnt[0]] % MOD;
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    precalc();

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}