#include <iostream>
#include "bits/stdc++.h"

using namespace std;
int N = 1024 * 1024;
using ll = long long;
#define int ll
#define str string
#define vec vector
struct Seg {
    vector<int> tree;
    int INF = 1e9;
    void init(vector<int> &a){
        tree.resize(4*a.size()+4);

    }

    void update(int i, int l, int r, int ind, int val) {
        if (ind < l || ind >= r) return;
        if (l + 1 == r) {
            tree[i] = val;
            return;
        }
        update(2 * i + 1, l, (l + r) / 2, ind, val);
        update(2 * i + 2, (l + r) / 2, r, ind, val);
        tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
    }

    int get(int i, int l, int r, int tl, int tr) {
        if (tl >= r || tr <= l) return -INF;
        if (l >= tl && r <= tr) return tree[i];
        return max(get(2 * i + 1, l, (l + r) / 2, tl, tr), get(2 * i + 2, (l + r) / 2, r, tl, tr));
    }
};

vector<vector<int>> h;
vector<int> d;
vector<int>ind;
vector<Seg>nice;
vector<vector<int>> graph;
vector<int>dp, tin, tout;
vector<int>dist;
int timer = 0;
void dfs(int start, int p, int l) {
    d[start] = l; tin[start] = timer++;
    dist[start] = 1e9; ind[start] = h[l].size();
    h[l].push_back(start);
    if(graph[start].empty()) dist[start] = d[start];
    for (auto val: graph[start]) {
        if (val == p) continue;
        dfs(val, start, l + 1);
        dist[start] = min(dist[val], dist[start]);
    }tout[start] = timer++;
}
void ans(int start, int p){
    dp[start] = 0;
    if(graph[start].empty()){
        return;
    }
    for(auto val: graph[start]){
        if(val == p) continue;
        ans(val, start);
        dp[start] = max(dp[start], dp[val]);
    }
    int v = dist[start];
    int l = -1; int r = h[v].size();
    while(l + 1 < r){
        int m = (l + r) / 2;
        if(tin[h[v][m]] >= tin[start]){
            r = m;
        }else l = m;
    }
    int le = -1; int re = h[v].size();
    while(le + 1 < re){
        int m = (le + re) / 2;
        if(tout[h[v][m]] > tout[start]) re = m;
        else le = m;
    }
    dp[start] = max(dp[start], nice[v].get(0, 0, h[v].size(), r, le + 1) + 1);
    nice[d[start]].update(0, 0, h[d[start]].size(), ind[start], dp[start]);
}
void solve() {
    int n;
    cin >> n;
    graph.resize(n);
    h.resize(n); nice.resize(n);
    tin.resize(n); tout.resize(n);
    d.resize(n); dp.resize(n); ind.resize(n);
    dist.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int a;
        cin >> a;
        int b = i + 1;
        a--;
        graph[a].emplace_back(b);
    }
    dfs(0, -1, 0);
    for(int i = 0; i < n; i++){
        nice[i].init(h[i]);
    }
    ans(0, -1);
    cout << dp[0];
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    solve();
    return 0;
}
