#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int inf = 1e18, M = 1e9 + 7;

struct node {
    char front, back;
    int pref, suf, mid, cnta, cntb;
};

node merge(node l, node r, int lb, int rb) {
    int m = (lb + rb) / 2;
    node ans;
    if (l.back == 'b' && r.front == 'b') ans.mid = max({l.mid, r.mid, l.suf + r.pref});
    else ans.mid = max(l.mid, r.mid);
    ans.front = l.front;
    ans.back = r.back;
    if (l.pref == m - lb) ans.pref = l.pref + r.pref;
    else ans.pref = l.pref;
    if (r.suf == rb - m) ans.suf = l.suf + r.suf;
    else ans.suf = r.suf;
    ans.cnta = l.cnta + r.cnta;
    ans.cntb = l.cntb + r.cntb;
    return ans;
}

int n;
vector<char> a;
vector<node> t;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v].front = t[v].back = a[l];
        t[v].pref = t[v].suf = t[v].mid = (a[l] == 'b');
        t[v].cnta = (a[l] == 'a');
        t[v].cntb = 1 - t[v].cnta;
        return;
    }
    int m = (l + r) / 2;
    build(2*v + 1, l, m);
    build(2*v + 2, m, r);
    t[v] = merge(t[2*v + 1], t[2*v + 2], l, r);
}

void upd(int v, int l, int r, int i) {
    if (l + 1 == r) {
        t[v].front = t[v].back = a[l];
        t[v].pref = t[v].suf = t[v].mid = (a[l] == 'b');
        t[v].cnta = (a[l] == 'a');
        t[v].cntb = 1 - t[v].cnta;
        return;
    }
    int m = (l + r) / 2;
    if (m > i) upd(2*v + 1, l, m, i);
    else upd(2*v + 2, m, r, i);
    t[v] = merge(t[2*v + 1], t[2*v + 2], l, r);
}

node get(int v, int l, int r, int beg, int end) {
    if (beg >= r || l >= end) return {'a', 'a', 0, 0, 0, 0, 0};
    if (beg <= l && r <= end) return t[v];
    int m = (l + r) / 2;
    return merge(get(2*v + 1, l, m, beg, end), get(2*v + 2, m, r, beg, end), l, r);
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    a.resize(n);
    t.resize(4*n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int i;
            cin >> i;
            --i;
            if (a[i] == 'a') a[i] = 'b';
            else a[i] = 'a';
            upd(0, 0, n, i);
        } else {
            int l, r;
            cin >> l >> r;
            --l; --r;
            auto res = get(0, 0, n, l, r + 1);
            int cnt = max({res.suf, res.pref, res.mid});
            int ok = 1;
            if (res.suf >= 2) ok = 0;
            if (res.pref >= 2) ok = 0;
            if (cnt >= 3) ok = 0;
            if (res.cnta < res.cntb + res.pref) ok = 0;
            if (ok) cout << "YES\n";
            else cout << "NO\n";
        }
    }
    return 0;
}
