#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <string> 
#include <set>

using namespace std;
using ll = long long;

const int mod = 1e9 + 7;

string s;
int N, k = 1;
struct Seg {
	bool a, f, b, m;
};

vector<Seg> tree;

Seg unite(Seg n1, Seg n2, int i) {
	Seg n = { false, false, false, false };
	if ((n1.a && n2.a) || (n1.f && n2.b && s[i] != s[i - 1])) {
		n.a = true;
	}
	if ((n1.b && n2.a) || (n1.m && n2.b && s[i] != s[i - 1])) {
		n.b = true;
	}
	if ((n1.a && n2.f) || (n1.f && n2.m && s[i] != s[i - 1])) {
		n.f = true;
	}
	if ((n1.b && n2.f) || (n1.m && n2.m && s[i] != s[i - 1])) {
		n.m = true;
	}
	return n;
}

void build(int x, int lx, int rx) {
	Seg& n = tree[x];
	if (rx - lx == 1) {
		if (s[lx] == 'a') {
			n.a = true;
		}
		else {
			n.a = false;
		}
		n.f = true;
		n.b = true;
		n.m = false;
		return;
	}
	int mx = (lx + rx) / 2;
	build(2 * x + 1, lx, mx);
	build(2 * x + 2, mx, rx);
	n = unite(tree[2 * x + 1], tree[2 * x + 2], mx);
}

void upd(int i, int x, int lx, int rx) {
	Seg& n = tree[x];
	if (rx - lx == 1) {
		if (s[lx] == 'a') {
			n.a = true;
		}
		else {
			n.a = false;
		}
		n.f = true;
		n.b = true;
		n.m = false;
		return;
	}
	int mx = (lx + rx) / 2;
	if (i < mx) {
		upd(i, 2 * x + 1, lx, mx);
	}
	else {
		upd(i, 2 * x + 2, mx, rx);
	}
	n = unite(tree[2 * x + 1], tree[2 * x + 2], mx);
}

Seg get_seg(int l, int r, int x, int lx, int rx) {
	if (lx >= r || l >= rx) {
		return { true, false, false, false };
	}
	if (lx >= l && rx <= r) {
		return tree[x];
	}
	int mx = (lx + rx) / 2;
	return unite(get_seg(l, r, 2 * x + 1, lx, mx), get_seg(l, r, 2 * x + 2, mx, rx), mx);
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cin >> N >> s;
	while (k < N) {
		k *= 2;
	}
	tree.resize(2 * k - 1);
	build(0, 0, k);
	int q;
	cin >> q;
	while (q--) {
		int c;
		cin >> c;
		if (c == 1) {
			int i;
			cin >> i;
			i--;
			if (s[i] == 'a') {
				s[i] = 'b';
			}
			else {
				s[i] = 'a';
			}
			upd(i, 0, 0, k);
		}
		else {
			int l, r;
			cin >> l >> r;
			l--;
			Seg ans = get_seg(l, r, 0, 0, k);
			if (ans.a) {
				cout << "YES\n";
			}
			else {
				cout << "NO\n";
			}
		}
	}
}