#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef vector<int> vi;
const int mod = 1e9 + 7;

struct node {
    int l = 0, r = 0; // кол-во ашек слево, колво ашек справа
    int sum = 0; // a sum
    int len = 1;
};

struct seg_tree {
    vector<node> tree;
    int size = 1;
    void init(int n, string &s) {
        while (size <= n) {
            size *= 2;
        }

        tree.resize(size * 2 - 1);
        for (int i = size - 1; i < size * 2 - 1; i++) {
            if (s[i - size + 1] == 'a') {
                tree[i].l = 1;
                tree[i].r = 1;
                tree[i].sum = 1;
            }
        }
    }

    node merge(node a, node b) {
        node res;
        if (a.l == a.len && b.l == b.len) {
            res.l = a.len + b.len;
            res.r = a.len + b.len;
            res.sum = 2;
        } else if (a.l == a.len) {
            res.l = a.len + b.l;//w
            res.r = b.r;
            res.sum = b.sum - b.l + min(2ll, a.len + b.l);
        } else if (b.l == b.len) {
            res.l = a.l;
            res.r = a.r + b.len;
            res.sum = a.sum - a.r + min(2ll, b.len + a.r);
        } else {
            res.l = a.l;
            res.r = b.r;
            res.sum = a.sum + b.sum - (a.r + b.l) + min(2ll, a.r + b.l);
        }

        res.len = a.len + b.len;
        return res;
    }

    void build(int v, int l, int r) {
        if (l == r) return;
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid + 1, r);
        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    void update(int ind, int v, int l, int r) {
        if (l == r) {
            if (tree[v].sum) {
                tree[v].l = 0;
                tree[v].r = 0;
                tree[v].sum = 0;
            } else {
                tree[v].l = 1;
                tree[v].r = 1;
                tree[v].sum = 1;
            }
            return;
        }

        int mid = (l + r) / 2;
        if (ind <= mid) {
            update(ind, v * 2 + 1, l, mid);
        } else {
            update(ind, v * 2 + 2, mid + 1, r);
        }

        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    node get(int ql, int qr, int v, int l, int r) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        if (qr <= mid) {
            return get(ql, qr, v * 2 + 1, l, mid);
        } else if (mid < ql) {
            return get(ql, qr, v * 2 + 2, mid + 1, r);
        }
        auto res1 = get(ql, qr, v * 2 + 1, l, mid);
        auto res2 = get(ql, qr, v * 2 + 2, mid + 1, r);
        return merge(res1, res2);
    }
};

struct seg_tree_b_sum {
    vector<int> tree;
    int size = 1;
    void init(int n, string &s) {
        while (size <= n) {
            size *= 2;
        }
        tree.resize(size * 2 - 1);
        for (int i = size - 1; i < size * 2 - 1; i++) {
            tree[i - size + 1] = s[i] == 'b';
        }
    }

    void build(int v, int l, int r) {
        if (l == r) return;
        int mid = ( l+ r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid + 1, r);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    void update(int ind, int v, int l, int r) {
        if (l == r) {
            tree[v] = !tree[v];
            return;
        }

        int mid = (l + r) / 2;
        if (ind <= mid) update(ind, v * 2 + 1, l, mid);
        else update(ind, v * 2 + 2, mid + 1, r);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
     }


    int get(int ql, int qr, int v, int l, int r) {
        if (r < ql || qr < l) return 0;
        if (ql <= l && r <= qr) return tree[v];
        int mid = (l + r) / 2;
        int res1 = get(ql, qr, v * 2 + 1, l, mid);
        int res2 = get(ql, qr, v * 2 + 2, mid + 1, r);
        return res1 + res2;
    }
};

void run_case(){
    int n;
    cin >> n;
    string t;
    cin >> t;
    string s;
    s = "a" + t + "a";
    n += 2;
    auto a_st = seg_tree();
    a_st.init(n, s);
    a_st.build(0, 0, a_st.size - 1);
    auto b_st = seg_tree_b_sum();
    b_st.init(n, s);
    b_st.build(0, 0, b_st.size - 1);


    set<pair<int, int>> base, error;
    int last = 0; // включительно в новом отрезке
    for (int i = 0; i < n -1 ; i++) {
        if (s[i] == 'b' && s[i + 1] == 'b') {
            base.insert({last, i});
            last = i + 1;
        }
    }
    base.insert({last, n - 1});

    for (auto [a, b] : base) {
        if (a_st.get(a, b, 0, 0, a_st.size - 1).sum < b_st.get(a, b, 0, 0, b_st.size - 1)) {
            error.insert({a,b});
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int type, ind;
        cin >> type;
        if (type == 1) {
            cin >> ind;
            if (s[ind] == 'a') {
                s[ind] = 'b';
                a_st.update(ind, 0, 0, a_st.size - 1);
                b_st.update(ind, 0, 0, b_st.size - 1);

                if (s[ind - 1] == 'a' && s[ind + 1] == 'a') continue;

                auto t = base.upper_bound({ind, 1e9});
                t--;
                auto seg = *t;
                base.erase(seg);
                error.erase(seg);
                vector<pair<int, int>> news;
                if (s[ind - 1] == 'b' && s[ind + 1] == 'b') {
                    news.emplace_back(seg.first, ind - 1);
                    news.emplace_back(ind, ind);
                    news.emplace_back(ind + 1, seg.second);
                } else if (s[ind - 1] == 'b') {
                    news.emplace_back(seg.first, ind - 1);
                    news.emplace_back(ind, seg.second);
                } else if (s[ind + 1] == 'b') {
                    news.emplace_back(seg.first, ind);
                    news.emplace_back(ind + 1, seg.second);
                }

                for (auto [a, b]: news) {
                    base.insert({a, b});
                    if (a_st.get(a, b, 0, 0, a_st.size - 1).sum < b_st.get(a, b, 0, 0, b_st.size - 1)) {
                        error.insert({a, b});
                    }
                }
            } else {
                s[ind] = 'a';
                a_st.update(ind, 0, 0, a_st.size - 1);
                b_st.update(ind, 0, 0, b_st.size - 1);

                if (s[ind - 1] == 'a' && s[ind + 1] == 'a') continue;

                auto t = base.upper_bound({ind, 1e9});
                t--;
                auto seg = *t;
                int l = seg.first, r = seg.second;
                vector<pair<int, int>> to_del = {seg};
                if (s[ind - 1] == 'b') {
                    auto pr = *prev(t);
                    l = pr.first;
                    to_del.emplace_back(pr);
                }

                if (s[ind + 1] == 'b') {
                    auto pr = *next(t);
                    r = pr.second;
                    to_del.emplace_back(pr);
                }

                for (auto el: to_del) {
                    base.erase(el);
                    error.erase(el);
                }

                vector<pair<int, int>> news = {{l, r}};
                for (auto [a, b]: news) {
                    base.insert({a, b});
                    if (a_st.get(a, b, 0, 0, a_st.size - 1).sum < b_st.get(a, b, 0, 0, b_st.size - 1)) {
                        error.insert({a, b});
                    }
                }
            }
        } else {
            int l, r;
            cin >> l >> r;

            auto t = error.upper_bound({l, 1e9});
            if (t != error.end() && t->second <= r) {
                cout << "NO\n";
                continue;
            }

            t = base.upper_bound({l, 1e9});
            if (t == base.end()) {
                int ll = l, rr = r;
                if (a_st.get(ll, rr, 0, 0, a_st.size - 1).sum < b_st.get(ll, rr, 0,0, b_st.size - 1)) {
                    cout << "NO\n";
                    continue;
                }else{
                    cout << "YES\n";
                }
                continue;
            }

            int ll = l, rr = t->first - 1;
            if (a_st.get(ll, rr, 0, 0, a_st.size - 1).sum < b_st.get(ll, rr, 0,0, b_st.size - 1)) {
                cout << "NO\n";
                continue;
            }

            t = base.upper_bound({r, 1e9});
            t--;
            ll = t->first, rr = r;
            if (a_st.get(ll, rr, 0, 0, a_st.size - 1).sum < b_st.get(ll, rr, 0,0, b_st.size - 1)) {
                cout << "NO\n";
                continue;
            }

            cout << "YES\n";
        }
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while(tt--)run_case();
}
