#include <bits/stdc++.h>
using namespace std;
using ll  = long long;
using ld = long double;
const int INF = 1e9;

const ll MOD = 1e9 + 7;
struct Residue {
    ll value;
    Residue(ll val): value(val) {
        if (value < -MOD || value >= 2 * MOD) value %= MOD;
        if (value < 0) value += MOD;
        if (value >= MOD) value -= MOD;
    }
    Residue(): Residue(0) {}
};

Residue operator+(Residue a, Residue b) {
    return {a.value + b.value};
}

Residue operator-(Residue a, Residue b) {
    return {a.value - b.value};
}

Residue operator*(Residue a, Residue b) {
    return {a.value * b.value};
}

istream& operator>>(istream& i, Residue &r) {
    i >> r.value;
    r = Residue(r.value);
    return i;
}

ostream& operator<<(ostream& o, Residue r) {
    return o << r.value;
}
Residue fact[5010];
Residue revfact[5010];
Residue binpow(Residue x, long long power) {
    Residue num = x;
    Residue ans = 1;
    while (power > 0) {
        if (power & 1) {
            ans = ans * num;
            power--;
        } else {
            num = num * num;
            power >>= 1;
        }
    }
    return ans;
}
Residue C(long long n, long long k) {
    if (k > n) {
        return 0;
    }
    return fact[n] * revfact[k] * revfact[n - k];
}
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fact[0] = 1;
    for (long long i = 1; i < 5010; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    revfact[5009] = binpow(fact[5009], MOD - 2);
    for (long long i = 5008; i >= 0; --i) {
        revfact[i] = revfact[i + 1] * (i + 1);
    }
    int n;
    cin >> n;
    Residue ans = 1;
    for (int i = 2; i <= n; i++) {
        Residue temp = 0;
        for (int x = 0; x <= i-1; x++) {
            temp = temp + C(i-1, x) * C(i-1-x, x+1);
        }
        ans = ans * temp;
    }
    cout << ans;
    return 0.4;
}