#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <deque>

using namespace std;

// #define int long long

const int mod = 1e9 + 7;

vector<int> least, h;
vector<vector<int>> gr;

void dfs1(int v) {
    least[v] = (gr[v].empty() ? 0 : (int)1e9);
    for (int u : gr[v]) {
        h[u] = h[v] + 1;
        dfs1(u);
        least[v] = min(least[v], least[u] + 1);
    }
}

vector<deque<int>> ret;
vector<int> dp;

void dfs2(int v) {
    ret[v].push_back(0);
    if (gr[v].size() == 0) return;
    int ind = -1;
    for (auto e : gr[v]) {
        dfs2(e);
        if (ind == -1 || ret[ind].size() < ret[e].size()) ind = e;
    }
    swap(ret[v], ret[ind]);
    for (auto e : gr[v]) {
        if (e != ind) {
            for (int i = 0; i < ret[e].size(); ++i) {
                ret[v][i] = max(ret[v][i], ret[e][i]);
            }
        }
    }
    dp[v] = ret[v][least[v] - 1] + 1;
    ret[v].push_front(dp[v]);
}

void solve() {
    int n;
    cin >> n;
    gr.resize(n);
    least.resize(n);
    h.resize(n);
    dp.resize(n);
    ret.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        gr[p].push_back(i);
    }
    dfs1(0);
    dfs2(0);
    cout << dp[0];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}